# transform.py
# ------------
# By MWC Contributors
# The functions in this module transform data. 
# None of them are finished; this is your job!

def maximum(data):
    "Returns the largest number in data"
    highest = None
    for number in data:
        if highest is None:
            highest = number
        if number > highest:
            highest = number
    return highest
    

def minimum(data):
    "Returns the smallest number in data"
    lowest = None
    for number in data:
        if lowest is None:
            lowest = number
        if number < lowest:
            lowest = number
    return lowest

def bounds(data):
    "Returns a list of the smallest and largest numbers in data"
    highest = maximum(data)
    lowest = minimum(data)
    return [lowest, highest]

def clamp(value, low, high):
    """Clamps a value to a range from low to high. 
    Returns value if it is between low and high.
    If value is lower than low, returns low. If value is higher than high, returns high.
    """
       
    if value < low:
        return low
    elif value > high:
        return high
    else:
        return value

def ratio(value, start, end):
    """Returns a number from 0.0 to 1.0, representing how far along value is from start to end.
    The return value is clamped to [0, 1], so even if value is lower than start, the return 
    value will not be lower than 0.0.
    """
    number = (value-start)/(end-start)

    number = clamp(number, 0.0, 1.0)
    return number


def scale(value, domain_min, domain_max, range_min, range_max):
    "Given a value within a domain, returns the scaled equivalent within range."
    scale = range_min + ((ratio(value, domain_min, domain_max))*(range_max - range_min))
    
    return scale

def get_x_values(points):
    "Returns the first value for each point in points."
    x_list = []
    for point in points:
        
        x = point[0]
        x_list.append (x)
    return x_list


def get_y_values(points):
    "Returns the second value for each point in points."
    y_list = []
    for point in points:
        
        y = point[1]
        y_list.append (y)
    return y_list


